import swarm.space.*;
import swarm.activity.*;
import swarm.defobj.*;
import swarm.objectbase.*;

import java.util.*;

public class ModelSwarm extends SwarmImpl{
	//functype:function number-CEC 2005 benchmark functions(1-12)
	//worldX/YSize:window size 
	//xMaxFrange [-xMax,xMax]
	//optimum,vector,matrix,matrix2,constant:parameters or constants
	public long seed;
	public int worldXSize,worldYSize,beeNum,functype,dim,tmax,limit;
	int scoutsWork;
	double optimum[],vector[];
	double matrix[][],matrix2[][];
	int t;//generations
	int flag,maxfiti;
	double constant;
	double xMax;
	double avgfit,maxfit,avgs,maxs,snds;
	Random rnd;
	
	MapSpace map;
	Grid2d world;
	
	Bee bees[];
	ActionGroup modelActions,modelActions2;
	Schedule modelSchedule;
	
	benchmark theBenchmark;
	test_func aTestFunc;
		
	public ModelSwarm(Zone aZone){
		super(aZone);
		seed=System.currentTimeMillis();
		worldXSize = 100;
		worldYSize = 100;
		beeNum =30;
		functype=1;
		dim=10;
		limit=300;
		tmax=0;
		t=0;
	}
	
	void setFunc(){
		if ((functype>=1)&&(functype<=25)){
			theBenchmark=new benchmark(seed);
			aTestFunc=theBenchmark.testFunctionFactory(functype, dim);
			if (functype<=6){
				xMax=100;
			}else if ((functype>=15)&&(functype<=24)){
				xMax=5;
			}else{
				switch(functype){
				case 7:
					xMax=300;//shift later
					break;
				case 8:
					xMax=32;
					break;
				case 9:
				case 10:
					xMax=5;
					break;
				case 11:
					xMax=0.5;
					break;
				case 12:
					xMax=Math.PI;
					break;
				case 13:
					xMax=5;
					break;
				case 14:
					xMax=100;
					break;
				case 25:
					xMax=1.5;//shift later
					break;
				}
			}
		}
	}

	
	public Object buildObjects(){
		//set seed
		rnd=new Random(seed);
		setFunc();
		initsim();
		return this;
	}
	
	public void initsim(){
		int i,sum;
		bees=new Bee[beeNum];
		map=new MapSpace(this,worldXSize,worldYSize);
		
		world=new Grid2dImpl(this,worldXSize,worldYSize);
		world.fillWithObject(null);		
		//set Bees
		for (i=0;i<beeNum;i++){
			bees[i]=new Bee(this,world,map,xMax,dim,bees,rnd);
		}
		//calculate first fitness
		sum=0;maxfit=0;
		for (i=0;i<beeNum;i++){
			bees[i].setf(fit(bees[i].getPos()));
			sum += bees[i].getf();
			if (maxfit<bees[i].getf()){
				maxfit=bees[i].getf();
			}
		}
		avgfit=sum/beeNum;
		t=0;
	}
	
	public Object buildActions(){
		return this;
	}
	
	public Activity activateIn(Swarm context){
    	super.activateIn (context);
		return getActivity();
	}
	
	public Grid2d getWorld(){
		return world;
	}
	
	public MapSpace getMap(){
		return map;
	}
	
	public Bee[] getBeeList(){
		return bees;
	}
	
	double func(double po[]){
		/*
		if (functype==0){
			return (result);
		}
		*/
		if ((functype>=1)&&(functype<=25)){
			if (functype==25){
				for (int i=0;i<dim;i++){
					po[i]+=3.5;
				}
			}
			if (functype==7){
				for (int i=0;i<dim;i++){
					po[i]+=300;
				}
			}
			return aTestFunc.f(po);
		}
		return 0;//avoid warning
	}
	
	double fit(double po[]){
		double f=func(po);
		if (f>0){
			return 1/(1+f);
		}else{
			return 1-f;
		}
	}
	
	boolean update(int i,int j){
		double newValue,newFit;
		double[] newPos,oldPos;
		int k,l;
		newPos=new double[dim];
		oldPos=bees[i].getPos();
		do{
			k=rnd.nextInt(dim);
			newValue=oldPos[k]+(oldPos[k]-(bees[j].getPos())[k])*(2*rnd.nextDouble()-1);
		}while((newValue<-xMax)|(newValue>xMax));
		for (l=0;l<dim;l++){
			if (l==k){
				newPos[l]=newValue;
			}else{
				newPos[l]=oldPos[l];
			}
		}
		newFit=fit(newPos);
		if (newFit>bees[i].getf()){
			bees[i].setPos(newPos);
			bees[i].setf(newFit);
			return true;
		}else{
			bees[i].adds();
			return false;
		}
	}
	public void step(){
		int i,j,k;double fitsum,p;
		t++;
		//employed bee
		for (i=0;i<beeNum;i++){
			while ((j=rnd.nextInt(beeNum))==i){
				//j is not equal to i
			}
			if (update(i,j)){
				bees[i].setBeeType(1);
			}
		}
		//onlooker bee
		for (k = 0; k < beeNum; k++) {
			fitsum = 0;maxfit=0;
			for (i = 0; i < beeNum; i++) {
				//sum of fitness
				fitsum += bees[i].getf();
				if (maxfit<bees[i].getf()){
					maxfit=bees[i].getf();
				}
			}
			avgfit=fitsum/beeNum;
			for (i = 0; i < beeNum; i++) {
				//probability for roulette 
				bees[i].setp(bees[i].getf() / fitsum);
			}
			i = 0;
			p = 1;
			//roulette
			while ((i < beeNum)
					&& (rnd.nextDouble() < (p - bees[i].getp()) / p)) {
				p = p - bees[i].getp();
				i++;
			}
			while ((j = rnd.nextInt(beeNum)) == i) {
				//j is not equal to i
			}
			if (update(i, j)){
				bees[i].setBeeType(2);
			}
		}
		
		//scout
		scoutsWork=0;
		for (i=0;i<beeNum;i++){
			if (maxfit<bees[i].getf()){
				maxfit=bees[i].getf();
				maxfiti=i;
			}
		}
		if (bees[maxfiti].gets()<maxs){
			snds=maxs;
			maxs=bees[maxfiti].gets();
		}
		flag=0;
		for (i=0;i<beeNum;i++){
			if (bees[i].gets()>=limit){
				scoutsWork++;
				bees[i].initialize(rnd);
				bees[i].setBeeType(3);
			}
		}
		//max fitness and the point and average fitness
		fitsum=0;maxfit=0;
		for (i = 0; i < beeNum; i++) {
			//sum of fitess
			bees[i].setf(fit(bees[i].getPos()));
			fitsum += bees[i].getf();
			if (maxfit<bees[i].getf()){
				maxfit=bees[i].getf();
			}
		}
		avgfit=fitsum/beeNum;
	}
	
	public double getAvgFitness(){
		return avgfit;
	}
	
	public double getMaxFitness(){
		return maxfit;
	}
	
	public int getScoutsWork(){
		return scoutsWork;
	}
	
	public int getT(){
		return t;
	}
	
	public double getMaxS(){
		return maxs;
	}
	
	public double get2ndS(){
		return snds;
	}
	
	public double getAvgS(){
		return avgs;
	}
}